#|

 Cells Gtk

 Copyright (c) 2004 by Vasilis Margioulas <vasilism@sch.gr>

 You have the right to distribute and use this software as governed by 
 the terms of the Lisp Lesser GNU Public License (LLGPL):

    (http://opensource.franz.com/preamble.html)
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 Lisp Lesser GNU Public License for more details.
 
|#

(defpackage :cells-gtk
  (:nicknames :cgtk)
  (:use :common-lisp :utils-kt :cells :gtk-ffi
    #+clisp :ffi #-clisp :uffi #-clisp #:ffx))

(in-package :cgtk)


(defun gtk-tree-store-set-kids (model val-tree par-iter index column-types print-fn children-fn &optional path)
  (with-tree-iter (iter)
    (gtk-ffi::gtk-tree-store-append model iter par-iter) ; sets iter
    (gtk-ffi::gtk-tree-store-set model iter
      column-types
      (append
       (funcall print-fn val-tree)
       (list (format nil "(~{~d ~})" (reverse (cons index path))))))
    (loop for sub-tree in (funcall children-fn val-tree)
          for pos from 0 do
           (gtk-tree-store-set-kids model sub-tree iter
            pos column-types print-fn children-fn (cons index path)))))