#|

 Gtk ffi

 Copyright (c) 2004 by Vasilis Margioulas <vasilism@sch.gr>

 You have the right to distribute and use this software as governed by 
 the terms of the Lisp Lesser GNU Public License (LLGPL):

    (http://opensource.franz.com/preamble.html)
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 Lisp Lesser GNU Public License for more details.
 
|#

(in-package :gtk-ffi)

(def-gtk-function :gtk gtk-check-menu-item-set-active :arguments
  ((check-menu c-pointer) (active boolean))
  :return-type nil :call-direct t)

#+test
(def-gtk-lib-functions :gtk
  (gtk-check-menu-item-set-active ((check-menu c-pointer)
				   (active boolean))))



(def-gtk-lib-functions :gtk
  ;;menu  
  (gtk-menu-shell-append ((menu-shell c-pointer)
			  (child c-pointer)))
  (gtk-menu-shell-prepend ((menu-shell c-pointer)
			  (child c-pointer)))
  (gtk-menu-shell-insert ((menu-shell c-pointer)
			  (child c-pointer)
			  (position int)))
  (gtk-menu-bar-new ()
    c-pointer)

  (gtk-menu-new ()
    c-pointer)
  (gtk-menu-set-title ((menu c-pointer)
		       (title c-string)))
  (gtk-menu-attach ((menu c-pointer)
		    (child c-pointer)
		    (lattach uint)
		    (rattach uint)
		    (tattach uint)
		    (battach uint)))
  (gtk-menu-attach-to-widget ((menu c-pointer)
			      (widget c-pointer)
			      (func #.(callback-function ((widget c-pointer)
							  (menu c-pointer))))))
			      
  (gtk-menu-popup ((menu c-pointer)
		   (p-menu-shell c-pointer)
		   (p-menu-item c-pointer)
		   (func #.(callback-function ((menu c-pointer)
					     (x (c-ptr int))
					     (y (c-ptr int))
					     (push-in (c-ptr boolean))
					     (data c-pointer))))
		   (data c-pointer)
		   (button uint)
		   (activate-time uint32)))

  (gtk-menu-item-new ()
    c-pointer)
  (gtk-menu-item-new-with-label ((label c-string))
    c-pointer)
  (gtk-menu-item-set-right-justified ((menu-item c-pointer)
				      (right-justified boolean)))
  (gtk-menu-item-set-submenu ((menu-item c-pointer)
			      (submenu c-pointer)))
  (gtk-menu-item-get-submenu ((menu-item c-pointer))
     c-pointer)
  (gtk-menu-item-remove-submenu ((menu-item c-pointer)))
  (gtk-menu-item-set-accel-path ((menu-item c-pointer)
				 (acell-path c-pointer)))
  (gtk-accel-map-add-entry ((accel-path c-pointer)
			    (accel-key uint)
			    (accel-mods int)))
  
  (gtk-check-menu-item-new ()
    c-pointer)
  (gtk-check-menu-item-new-with-label ((label c-string))
    c-pointer)
  #+above (gtk-check-menu-item-set-active ((check-menu c-pointer)
				   (active boolean)))
  (gtk-check-menu-item-get-active ((check-menu c-pointer))
    boolean)

  (gtk-radio-menu-item-new ((group c-pointer))
    c-pointer)
  (gtk-radio-menu-item-new-from-widget ((group c-pointer))
    c-pointer)
  (gtk-radio-menu-item-new-with-label ((group c-pointer)
				       (label c-string))
    c-pointer)
  (gtk-radio-menu-item-new-with-label-from-widget ((radio c-pointer)
						   (label c-string))
    c-pointer)
  (gtk-radio-menu-item-get-group ((radio c-pointer))
    c-pointer)
  
  (gtk-image-menu-item-new ()
    c-pointer)
  (gtk-image-menu-item-new-with-label ((label c-string))
    c-pointer)
  (gtk-image-menu-item-new-from-stock ((stock-id c-string)
				       (accel-group c-pointer))
    c-pointer)
  (gtk-image-menu-item-set-image ((menu-item c-pointer)
				  (image c-pointer)))
				  

  (gtk-separator-menu-item-new ()
    c-pointer)
  (gtk-tearoff-menu-item-new ()
    c-pointer))

